#COMPILE EXE
#DIM ALL

#INCLUDE "WIN32API.inc"

GLOBAL CounterTSC1, CounterTSC2, CounterOverhead , CounterCycles AS QUAD
GLOBAL LoopCounter AS LONG

MACRO COUNTER_BEGIN( nLoops, priority_class )

    CounterOverhead = 2000000000
    CounterCycles   = 2000000000

    CALL SetPriorityClass( GetCurrentProcess, priority_class )

    FOR LoopCounter = 1 TO nLoops

        ! xor eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC1, eax
        ! mov CounterTSC1[4], edx

        ! xor eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC2, eax
        ! mov CounterTSC2[4], edx

        IF (CounterTSC2 - CounterTSC1) < CounterOverhead THEN CounterOverhead = CounterTSC2 - CounterTSC1

    NEXT

    SLEEP 0

    '' To ensure that the overhead for the reference loop will match
    '' the overhead for the test loop, regardless of the position of
    '' the macro code in memory, the entry point for the reference
    '' loop should be a multiple of 16 bytes from the entry point of
    '' the test loop. The current distance is 112 bytes.

    FOR LoopCounter = 1 TO nLoops

        ! xor eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC1, eax
        ! mov CounterTSC1[4], edx

END MACRO

MACRO COUNTER_END

        ! xor eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC2, eax
        ! mov CounterTSC2[4], edx

        IF (CounterTSC2 - CounterTSC1) < CounterCycles THEN CounterCycles = CounterTSC2 - CounterTSC1

    NEXT

    CALL SetPriorityClass( GetCurrentProcess, %NORMAL_PRIORITY_CLASS )
    CounterCycles = CounterCycles - CounterOverhead

END MACRO

FUNCTION PBMAIN

'#REGISTER NONE

    LOCAL s AS STRING
    LOCAL seed, lBase, nLoops AS LONG ' base is a reserved PB word

    seed   = 123
    lBase  = 100  

    nLoops = 1000000
                   
    SLEEP 3000

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)
        ! XOR edx, edx
        ! mov eax, 1
        ! div ecx
    COUNTER_END
    s = STR$(CounterCycles) + $CRLF

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)
        ! rcr eax, 31
        ! rcl eax, 31
    COUNTER_END
    s = s + STR$(CounterCycles) + $CRLF

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)
        ! pushad
        ! popad
    COUNTER_END
    s = s + STR$(CounterCycles) + $CRLF

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)

        ! mov eax, seed
        ! test eax, &h80000000
        ! jz  L1
        ! add eax, &h7fffffff
    L1:
        ! xor edx, edx
        ! mov ecx, 127773
        ! div ecx
        ! mov ecx, eax
        ! mov eax, 16807
        ! mul edx
        ! mov edx, ecx
        ! mov ecx, eax
        ! mov eax, 2836
        ! mul edx
        ! sub ecx, eax
        ! xor edx, edx
        ! mov eax, ecx
        ! mov seed, ecx
        ! div lBase
        ! mov eax, edx

    COUNTER_END
    s = s + STR$(CounterCycles) + $CRLF

    MSGBOX s

    EXIT FUNCTION

END FUNCTION